# class Gem::Resolver::ComposedSet

A `ComposedSet` allows multiple sets to be queried like a single set.

To create a composed set with any number of sets use:

    Gem::Resolver.compose_sets set1, set2

This method will eliminate nesting of composed sets.

### Public Class Methods

new (*sets)
Source

    # File lib/rubygems/resolver/composed_set.rb, line 19
    def initialize(*sets)
      super()

      @sets = sets
    end

Creates a new `ComposedSet` containing `sets`. Use `Gem::Resolver::compose_sets` instead.

Calls superclass method `BasicObject::new`

### Public Instance Methods

errors ()
Source

    # File lib/rubygems/resolver/composed_set.rb, line 46
    def errors
      @errors + @sets.flat_map(&:errors)
    end

find_all (req)
Source

    # File lib/rubygems/resolver/composed_set.rb, line 53
    def find_all(req)
      @sets.flat_map do |s|
        s.find_all req
      end
    end

Finds all specs matching `req` in all sets.

prefetch (reqs)
Source

    # File lib/rubygems/resolver/composed_set.rb, line 62
    def prefetch(reqs)
      @sets.each {|s| s.prefetch(reqs) }
    end

Prefetches `reqs` in all sets.

prerelease= (allow_prerelease)
Source

    # File lib/rubygems/resolver/composed_set.rb, line 29
    def prerelease=(allow_prerelease)
      super

      sets.each do |set|
        set.prerelease = allow_prerelease
      end
    end

When `allow_prerelease` is set to `true` prereleases gems are allowed to match dependencies.

Calls superclass method
remote= (remote)
Source

    # File lib/rubygems/resolver/composed_set.rb, line 40
    def remote=(remote)
      super

      @sets.each {|set| set.remote = remote }
    end

Sets the remote network access for all composed sets.

Calls superclass method